# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from command import command, swrapper
from cxutil import flags,utils,cmask,pmask

from cxcore.cxnetlink import cl_mutex
import traceback

CL_DOMAIN = "_cxheartbeat._udp.local"

class create (command):
	'''
	Create mutex (see also: acquire, release)
	'''
	mask = flags.Esoteric | flags.Internal | flags.Immediate
	parameters = {
		"$1": {
			"description": "mutex name",
			"type": "word",
			"name": "name",
		}
	}

	def postUp (self, opts):

		# FIXME: one should catch errors of zone creation
		if not opts.envg.has_key("mutex"):
			opts.envg.mutex = {}
		opts.envg.mutex[opts.envl.name] = cl_mutex(opts.esoteric.bus, "%s.%s." % (opts.envl.name, CL_DOMAIN), "%s." % (CL_DOMAIN))
